<?php
/********************************************
* NetMRG Integrator
* 
* config.php
* Static Configuration Module
*
* see doc/LICENSE for copyright information
********************************************/

/***** GLOBAL SETTINGS *****/ 
error_reporting(E_WARNING | E_ERROR);

/***** CONFIG *****/
// Cosmetic Variables
$GLOBALS["netmrg"]["version"]           = "0.18.2";
$GLOBALS["netmrg"]["name"]              = "NetMRG";

// DB Config
$GLOBALS["netmrg"]["dbdebug"]           = false;

// Path Config
$GLOBALS["netmrg"]["libdir"]            = "..";
$prefix = "/usr";
$GLOBALS["netmrg"]["xmlfile"]           = "/etc/netmrg/netmrg.xml";

// Authentication Config
$GLOBALS["netmrg"]["authTimeout"]       = 86400; // 24hr * 60min * 60sec
$GLOBALS["netmrg"]["defaultMapUser"]    = "NETMRG_DEFAULT_MAP";

// Template Config
$GLOBALS["netmrg"]["traffictemplateid"] = 7;
$GLOBALS["netmrg"]["disktemplateid"]	= 8;


/***** SESSION *****/
session_start();
if (!isset($_SESSION["netmrgsess"]) || !is_array($_SESSION["netmrgsess"]))
{
	$_SESSION["netmrgsess"] = array();
	$_SESSION["netmrgsess"]["prettyname"] = "";
	$_SESSION["netmrgsess"]["username"] = "";
	$_SESSION["netmrgsess"]["password"] = "";
	$_SESSION["netmrgsess"]["accessTime"] = "";
	$_SESSION["netmrgsess"]["remote_addr"] = "";
	$_SESSION["netmrgsess"]["permit"] = "";
	$_SESSION["netmrgsess"]["group_id"] = "";
} // end if the netmrg session array doesn't exist yet, make it



/***** INCLUDES *****/
require_once($GLOBALS["netmrg"]["libdir"]."/lib/xml_to_array.php");
require_once($GLOBALS["netmrg"]["libdir"]."/lib/processing.php");



/***** XML CONFIG *****/
GetXMLConfig();
    $GLOBALS["netmrg"]["binary"]         = "/usr/bin/netmrg-gatherer";
    $GLOBALS["netmrg"]["staticimagedir"] = "{$GLOBALS['netmrg']['webroot']}/img";
    $GLOBALS["netmrg"]["imagebasedir"]   = "{$GLOBALS['netmrg']['fileroot']}/webfiles/images/default";



/***** INCLUDES *****/
require_once($GLOBALS["netmrg"]["libdir"]."/lib/database.php");
require_once($GLOBALS["netmrg"]["libdir"]."/lib/menu.php");
require_once($GLOBALS["netmrg"]["libdir"]."/lib/stat.php");
require_once($GLOBALS["netmrg"]["libdir"]."/lib/format.php");
require_once($GLOBALS["netmrg"]["libdir"]."/lib/auth.php");
require_once($GLOBALS["netmrg"]["libdir"]."/lib/snmp_caching.php");
require_once($GLOBALS["netmrg"]["libdir"]."/lib/misc.php");
require_once($GLOBALS["netmrg"]["libdir"]."/lib/graphing.php");
require_once($GLOBALS["netmrg"]["imagebasedir"]."/imagespec.php");



/***** STARTUP *****/
$GLOBALS["netmrg"]["dbconn"]    = db_connect();
$GLOBALS["netmrg"]["dbversion"] = GetDBVersion();

// magic_quotes_gpc workaround
if (!get_magic_quotes_gpc())
{
	$_REQUEST = array_map('addslashes_deep', $_REQUEST);
	$_SERVER = array_map('addslashes_deep', $_SERVER);
	$_COOKIE = array_map('addslashes_deep', $_COOKIE);
} // end if no magic quotes gpc, do it ourselves

?>
